//############################################################################//
//             Copyright (c) 2004, Apycom Software, wwww.apycom.com
//             Apycom DHTML Tuner script
//             http://dhtml-menu.com
//             Programming by Shakhmatov Nik
//             E-mail: dhtml@apycom.com
//############################################################################//

var apy_tunerItems = [];
var apy_keys = [];

var apy_tunerStyles0 = [];
var apy_tunerStyles1 = [];
var apy_tunerStyleNames0 = [];
var apy_tunerStyleNames1 = [];


var waitFor=null;


//############################################################################//
//  Functions for interaction
//############################################################################//

function apy_getValue(paramType, editID)    // used by script
{
  if (waitFor!=null) return;
  var e = document.getElementById(editID);
  waitFor = e;
  status = '@'+paramType+':'+e.value;
}


function apy_setValue(val)                  // used by Tuner
{
  if (waitFor!=null) waitFor.value = val;
  waitFor=null;
}


//############################################################################//
//  Functions for data saving
//############################################################################//

var paramValueExists = false;

function apy_getParamValue(pName, pType, pDefValue, curProjectPath, commaChar)
// Returns param value for saving
{
  var obj = document.getElementById(pName+'_id');
  if (!obj) return commaChar+commaChar;
  
  switch (pType)
  {
    case 'integer':
    case 'integer-nn':
    case 'boolean':
    case 'effect':
        paramValueExists = (obj.value)?true:false;
        return (obj.value)?obj.value:commaChar+commaChar;
    break;


    case 'set':
    case 'set-add':
        var val = apy_getParam_setadd(pName);
        paramValueExists = (val!='')?true:false;
        return commaChar+val+commaChar;
    break;
    
    
    case 'image':
        var prefix='';
        if (obj.value && obj.value.charAt(1)!=':') prefix = curProjectPath;
        
        paramValueExists = (obj.value)?true:false;
        return commaChar+prefix+obj.value+commaChar;
    break;

    
    case 'color-array':
    case 'image-array':
    case 'set-array':
    case 'string-array':
    case 'font-array':
        var val='[', tmpVal='';
        var itemType = pType.replace(/-array/i, '');
        var valueExists = false;
        
        for (var i=0; i<pDefValue.length; i++)
        {
            tmpVal = apy_getParamValue(pName+'_item'+i, itemType, pDefValue[i], curProjectPath, commaChar);
            if (tmpVal!=(''+commaChar+commaChar)) valueExists = true;
            val += tmpVal + ((i<pDefValue.length-1)?',':'');
        }

        val += ']';
        paramValueExists = valueExists;
        return val;
    break;


    default:
        paramValueExists = (obj.value!='')?true:false;
        return commaChar+obj.value+commaChar;
  }
}


function apy_getLineEnd() {
  return String.fromCharCode(13)+String.fromCharCode(10);
}


function apy_getParamsList(curProjectPath)            // used by Tuner
// Returns parameters list for data file
{
  var paramList = '';
  var pName, pType, pValue;
  
  for (var i=0; i<apy_tunerParams.length; i++)
  {
      pType = apy_getParam(i, 1);
      if (pType && pType!='separator')
      {
          pName  = apy_getParam(i, 0);
          if (pType!='section')
          {
              pValue = apy_getParamValue(pName, pType, apy_getParam(i, 2), curProjectPath, '"');
              paramList += 'var '+pName+' = '+pValue+';' + apy_getLineEnd();
          }
          else
              paramList += apy_getLineEnd() + '//------- '+pName + ' -------' + apy_getLineEnd();
      }
  }

  return paramList;
}


function apy_getKeysList()                            // used by Tuner
// Returns key list for data file
{
  var keysList = '';
  for (var i=0; i<apy_keys.length; i++)
      keysList += 'var key'+((i==0)?'':i) + '="'+apy_keys[i]+'";' + apy_getLineEnd();

  return keysList;
}


function apy_getStylesArray(curProjectPath)           // used by Tuner
// Returns styles arrays for data file
{
  var pName, pType, pValue;
  var stylesArr = '[';
  var n=0;

  for (var i=0; i<apy_tunerParams.length; i++)
  {
      pType = apy_getParam(i, 1);
      if (pType && pType!='section' && pType!='separator')
      {
          pName  = apy_getParam(i, 0);
          pValue = apy_getParamValue(pName, pType, apy_getParam(i, 2), curProjectPath, '');
          if (paramValueExists)
          {
              pValue = pValue.replace(/\[/g, '');        // delete array brackets
              pValue = pValue.replace(/\]/g, '');        // --=--
              stylesArr += (n?',':'') + '"'+pName+'='+pValue+'"';
              n++;
          }
      }
  }

  return stylesArr+']';
}


//############################################################################//
//  Additional functions for parameters
//############################################################################//

function apy_setParam(pInd, pName, pType, pValue)
// Sets parameter value using p. name, p. type and p. value
{
  switch (pType)
  {
    case 'set-add':
    case 'set':
        apy_setParam_setadd(pName, pValue);
    break;


    case 'color-array':
    case 'image-array':
    case 'set-array':
    case 'string-array':
    case 'font-array':
        var itemType = pType.replace(/-array/i, '');
        for (var i=0; i<pValue.length; i++)
        {
            if (typeof(pValue[i])=='undefined') pValue[i] = '';
            apy_setParam(pInd, pName+'_item'+i, itemType, pValue[i]);
        }
    break;

    case 'effect':
        obj = document.getElementById(pName+'_id');
        objSel = document.getElementById(obj.id+'_sel');
        if (obj) obj.value = pValue;
        objSel.selectedIndex = pValue;
    break;

    default:
        obj = document.getElementById(pName+'_id');
        if (obj) obj.value = pValue;
  }
}


function apy_getDefaultValue(pType, pDefValue)
// Returns corrected value from default parameter value
{
  switch (pType)
  {
    case 'set-add':
    case 'set':
        return pDefValue.split(',')[0];
    break;


    case 'color-array':
    case 'image-array':
    case 'set-array':
    case 'string-array':
    case 'font-array':
        var itemType = pType.replace(/-array/i, '');
        var result=[];
        for (var i=0; i<pDefValue.length; i++)
            result[i] = apy_getDefaultValue(itemType, pDefValue[i]);

        return result;
    break;
    

    default: return pDefValue;
  }
}



function apy_resetParams()                  // used by Tuner
// Resets all parameters values on a page
{
  var pName, pType, pDefValue, pValue;

  canModify = false;
  for (var i=0; i<apy_tunerParams.length; i++)
  {
      pType = apy_getParam(i,1);
      if (pType && pType!='separator' && pType!='section')
      {
          pName     = apy_getParam(i,0);
          pDefValue = apy_getParam(i,2);
          apy_setParam(i, pName, pType, apy_getDefaultValue(pType, pDefValue));
      }
  }
  apy_tunerItems = [];         // reset menu items
  canModify = true;
}


//############################################################################//
//  Functions for data loading
//############################################################################//

function apy_preDefineVars()
// Defines parameters script variables according to default parameters values
{
  var pName, pType, pDefValue, pValue;
  var preScript='';

  for (var i=0; i<apy_tunerParams.length; i++)
  {
      pType = apy_getParam(i,1);
      if (pType && pType!='separator' && pType!='section')
      {
          pName     = apy_getParam(i,0);
          pDefValue = apy_getParam(i,2);
          pValue    = apy_getParamValue(pName, pType, pDefValue, '', '"');
          preScript += pName + '=' + pValue +';'+String.fromCharCode(13);
      }
  }

  eval(preScript);
}


function apy_loadParams(script, itemsName, stylesName0, stylesName1)  // used by Tuner
// Loads parameters variables from specified script code
{
  var pName, pType, pValue;
  apy_preDefineVars();
  eval(script);
  canModify = false;
  for (var i=0; i<apy_tunerParams.length; i++)
  {
      pType = apy_getParam(i,1);
      if (pType && pType!='separator' && pType!='section')
      {
          pName = apy_getParam(i,0);
          eval('pValue = ' + pName + ';');        // set pValue value
          apy_setParam(i, pName, pType, pValue);
      }
  }
  canModify = true;

  eval('apy_tunerItems = ' + itemsName + ';');                           // load menu items

  //--- Load individual styles -------------------------------------------------
  if (stylesName0)                                // load item styles
  {
      eval('if (typeof('+stylesName0+')!="undefined") apy_tunerStyles0='+stylesName0+'; else apy_tunerStyles0=[];');
      eval('if (typeof('+stylesName0+'Names)!="undefined") apy_tunerStyleNames0='+stylesName0+'Names; else apy_tunerStyleNames0=[];');
  }
  else
  {
      apy_tunerStyles0=[];
      apy_tunerStyleNames0=[];
  }

  if (stylesName1)                                // load menu styles
  {
      eval('if (typeof('+stylesName1+')!="undefined") apy_tunerStyles1='+stylesName1+'; else apy_tunerStyles1=[];');
      eval('if (typeof('+stylesName1+'Names)!="undefined") apy_tunerStyleNames1='+stylesName1+'Names; else apy_tunerStyleNames1=[];');
  }
  else
  {
      apy_tunerStyles1=[];
      apy_tunerStyleNames1=[];
  }
  //----------------------------------------------------------------------------

  apy_keys = [];
  if (typeof(key)!='undefined')
  {
      apy_keys[0] = key;
      kInd=1;
      while (eval('typeof(key'+kInd+')!="undefined"'))
      {
          eval('apy_keys['+kInd+']=key'+kInd+';');
          kInd++;
      }
  }
}


//############################################################################//
//  Functions for styles loading (used by Tuner for internal style names)
//############################################################################//

function apy_getStyleParamsCount(stylesType) {
  return (stylesType==0)?apy_tunerStyles0.length:apy_tunerStyles1.length;
}


function apy_getStyleName(stylesType, styleInd)
// Returns style name for specified style type
{
  var Names = (stylesType==0)?apy_tunerStyleNames0:apy_tunerStyleNames1;

  if (typeof(Names[styleInd])!='undefined')
      return Names[styleInd];
  else
      return '';
}


function apy_getStyleParamsList(stylesType, styleInd)
// Returns specified style parameter
{
  var style = (stylesType==0)?apy_tunerStyles0[styleInd]:apy_tunerStyles1[styleInd];

  if (typeof(style)=='undefined' || !style) return '';
  
  var params='';
  for (var i=0; i<style.length; i++)
      if (typeof(style[i]!='undefined') && style[i]) params += '"' + style[i] + '"' + ((i<style.length-1)?',':'');
          
  return params;
}


//############################################################################//
//  Functions for menu items
//############################################################################//

function apy_getItemsCount() {
  return apy_tunerItems.length;
}


function apy_getItemParam(itemInd, paramInd)
// Returns item parameter
{
  if (typeof(apy_tunerItems[itemInd])=='undefined')
      return '@undefined';
  else
      if (typeof(apy_tunerItems[itemInd][paramInd])!='undefined')
          return apy_tunerItems[itemInd][paramInd];
}


