//############################################################################//
//             Copyright (c) 2004, Apycom Software, wwww.apycom.com
//             Apycom DHTML Tuner script
//             http://dhtml-menu.com
//             Programming by Shakhmatov Nik
//             E-mail: dhtml@apycom.com
//############################################################################//

var apy_paramPrefix = '@parameter-';

var apy_ID_paramName = '@paramName';
var apy_ID_value     = '@value';
var apy_ID_hint      = '@hint';
var apy_ID_id        = '@id';

var apy_paramTypes = ['integer', 'integer-nn', 'integer-percent', 'percent',
                      'boolean', 'string',     'image', 'font',
                      'set',     'set-add',    'color', 'effect',
                      'section', 'separator',

                      'color-array',  'color-array-item',
                      'image-array',  'image-array-item',
                      'string-array', 'string-array-item',
                      'set-array',    'set-array-item',
                      'font-array',   'font-array-item'];

var apy_paramTypeTmpls = [];


var idName  = new RegExp(apy_ID_paramName, 'g');
var idValue = new RegExp(apy_ID_value,     'g');
var idHint  = new RegExp(apy_ID_hint,      'g');
var idId    = new RegExp(apy_ID_id,        'g');
var idBreak = new RegExp('>>', 'g');

var a = navigator.userAgent;
b_VER = parseFloat (a.substring(a.indexOf("MSIE ")+5, a.length));

//############################################################################//
//  Functions for parameters creation
//############################################################################//

function apy_readParamTemplates()
// Saves parameter templates
{
  var obj;
  for (var i=0; i<apy_paramTypes.length; i++)
  {
      obj = document.getElementById(apy_paramPrefix+apy_paramTypes[i]);
      apy_paramTypeTmpls[i] = (obj?obj.innerHTML:'');
  }
}


function apy_getTmplForType(typeName)
// Returns template for specified parameter type
{
  if (typeName=='undefined') return '';
  for (var i=0; apy_paramTypes[i]!=typeName && i<apy_paramTypes.length; i++) continue;
  if (apy_paramTypes[i]!=typeName)
  {
      //alert('There is no such type:' + String.fromCharCode(13) + typeName);
      return '';
  }
  else
      return apy_paramTypeTmpls[i];
}


function apy_buildParam(pHTML, pName, pType, pValue)
// Creates complete code from template for specified parameters' type
{
  var s='';
  switch (pType)
  {
    case 'section':
        var idIcon = new RegExp('@image', 'g');
        pHTML = pHTML.replace(idIcon, pValue+'.gif');
    break;
    

    case 'set-add':
    case 'set':
        if (b_VER>=5.5)
            var idSetValue = new RegExp('<OPTION value=@'+pType+'value selected>', 'i');
        else
            var idSetValue = new RegExp('<OPTION selected value=@'+pType+'value>', 'i');

        var values = pValue.split(',');
        for (var i=0; i<values.length; i++)
            s += '<option value='+i+'>'+values[i];

        if (pType=='set-add')
            s += '<option value='+(i+1)+'>custom...';

        pHTML = pHTML.replace(idSetValue, s);

    break;


    case 'color-array':
    case 'image-array':
    case 'set-array':
    case 'string-array':
    case 'font-array':
        var itemTmpl  = apy_getTmplForType(pType+'-item');
        var itemsTmpl = '';
        var _itemTmpl;


        for (var i=0; i<pValue.length; i++)
        {
            _itemTmpl = itemTmpl;
            _itemTmpl = _itemTmpl.replace(idId, pName+'_item'+i+'_id');

            if (pType=='set-array')
                _itemTmpl = apy_buildParam(_itemTmpl, '', 'set', pValue[i]);
            else
                _itemTmpl = _itemTmpl.replace(idValue, "'"+pValue[i]+"'");

            itemsTmpl += _itemTmpl;
        }

        var idItem = new RegExp(apy_paramPrefix+pType+'-item', 'g');
        pHTML = pHTML.replace(idItem, itemsTmpl);

    break;
  }

  return pHTML;
}


function apy_showHint(pInd)
{
  var idBr = new RegExp('>>', 'g');
  window.status = '@showHint:Parameter: ' + apy_getParam(pInd,0) + String.fromCharCode(13) + '--------------------------' + String.fromCharCode(13) + apy_getParam(pInd,3).replace(idBr, String.fromCharCode(13));
}


function apy_showHint2(text)
{
  var idBr = new RegExp('>>', 'g');
  window.status = '@showHint:'+text.replace(idBr, String.fromCharCode(13));
}


function apy_buildParamList()
// Creates completed parameters content
{
  var s='', ps='', hint='', hintBtn='', helpURL='';
  var pName, pType, pValue;

  for (var i=0; i<apy_tunerParams.length; i++)
  {
      pName  = apy_getParam(i,0);
      pType  = apy_getParam(i,1);
      pValue = apy_getParam(i,2);
      hint   = apy_getParam(i,3).replace(idBreak, String.fromCharCode(13));

      ps = apy_getTmplForType(pType);

      hintBtn = (pType!='section' && pType!='separator')?'<span class="hintButton" onClick="apy_showHint('+i+');">&nbsp;?&nbsp;</span>&nbsp;':'';
      helpURL = (apy_getParam(i,4)?'<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href="'+apy_getParam(i,4)+'" target="_blank" title="Click to show additional information.">Additional info</a>':'');
      
      ps = ps.replace(idName,  hintBtn + pName + helpURL);
      ps = ps.replace(idValue, "'"+pValue+"'");
      ps = ps.replace(idId,    pName+'_id');

      ps = ps.replace(idHint,  "'"+hint+"'");

      ps = apy_buildParam(ps, pName, pType, pValue);
      s += ps;
  }
  
  s += '<br><br>';
  
  document.body.innerHTML = s;
}


//############################################################################//
//  Initial functions
//############################################################################//

var canModify = true;

function apy_Modified() {
  if (canModify) status = '@modified:null';
}


function apy_setChangeEvents(tagName)
// Assigns events for specified objects (tags)
{
  var objs = document.getElementsByTagName(tagName);
  for (var i=0; i<objs.length; i++) objs[i].attachEvent('onpropertychange', apy_Modified);
}


function apy_reCreateParams()
// Re-builds parameters page
{
  apy_buildParamList();
  apy_setChangeEvents('INPUT');
  apy_setChangeEvents('SELECT');
}


function apy_initialize()
// Initializes page
{
  apy_readParamTemplates();
  apy_reCreateParams();
}


function apy_getParam(paramInd, fieldInd) {
  return (typeof(apy_tunerParams[paramInd])!='undefined')?apy_tunerParams[paramInd][fieldInd]:'';
}


//############################################################################//
//  Functions for page
//############################################################################//

function apy_setaddChange(selObj)
// Executed for <select> onChange event
{
  with (selObj)
      document.getElementById(id+'_edit').style.display = (selectedIndex==options.length-1)?'':'none';
}


function apy_changeParamBtn(obj, className) {
  obj.className = className;
}


function apy_setParam_setadd(pName, pValue)
// Sets <select> value for types: set, set-add
{
  var selObj  = document.getElementById(pName+'_id');
  var editObj = document.getElementById(selObj.id+'_edit');

  for (var i=0; i<selObj.options.length; i++)
      if (selObj.options[i].text==pValue)
      {
          selObj.selectedIndex = i;
          if (editObj)
          {
              editObj.style.display = 'none';
              editObj.value = '';
          }
          return;
      }

  selObj.selectedIndex = selObj.options.length-1;
  if (editObj)
  {
      editObj.value = pValue;
      editObj.style.display = '';
  }
}


function apy_getParam_setadd(pName)
// Returns parameter value from object for types: set, set-add
{
  var selObj  = document.getElementById(pName+'_id');
  var editObj = document.getElementById(selObj.id+'_edit');

  if (selObj.selectedIndex == selObj.options.length-1 && editObj)
      return editObj.value;
  else
      return selObj.options[selObj.selectedIndex].text;
}





